package com.persagy.adm.diagram.controller;

import com.persagy.adm.diagram.frame.EditRequest;
import com.persagy.adm.diagram.manage.DemoDiagramManager;
import com.persagy.adm.diagram.manage.Folder;
import com.persagy.adm.diagram.core.model.Diagram;
import com.persagy.dmp.common.model.response.CommonResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@RestController
@CrossOrigin
@RequestMapping("diagram0")
public class DemoDiagramController {

	@Autowired
	private DemoDiagramManager diagramManager;

	@RequestMapping("getDiagrams")
	public CommonResult<List<Folder>> getDiagrams(@RequestParam String projectId, @RequestParam(required = false) String systemId, @RequestParam(required = false) String groupCode){
		return CommonResult.success(diagramManager.getDiagrams(projectId, systemId, groupCode));
	}

	@RequestMapping("newDiagram")
	public CommonResult<Diagram> newDiagram(@RequestBody Map<String, String> params, @RequestParam String projectId, @RequestParam(required = false) String systemId, @RequestParam(required = false) String groupCode){
		return CommonResult.success(diagramManager.createDiagram(params.get("name"), params.get("type"), projectId, systemId, groupCode));
	}

	@RequestMapping("delDiagram")
	public CommonResult<Boolean> delDiagram(@RequestBody Map<String, String> params){
		return CommonResult.success(diagramManager.deleteDiagram(params.get("id")));
	}

	@RequestMapping("setTemplate")
	public CommonResult<Diagram> setTemplate(@RequestBody EditRequest req){
		return CommonResult.success(diagramManager.setTemplate(req.getDiagramId(), req.getTemplateId()));
	}

	@RequestMapping("loadData")
	public CommonResult<Diagram> loadData(@RequestBody EditRequest req) {
		return CommonResult.success(diagramManager.loadData(req.getDiagramId(), true));
	}

}
